:: :: Changes from 0.11 to 0.12

Bugfixes:
- BE could kick people who had BE disabled because of packetloss.
- BE could kick people who were downloading the map because of packetloss.
- Querying list of servers from master was not working for mods.
- There were still some server crashes, with message talking about "zlib".
- Overly long screenshot names could have .jp extension instead of .jpg.
- cg_crosshair_color setting was not working correctly after vid_restart.
- Flag stats for the HUD were not working.
- Armor and health still decayed while in timeout.
- Armor had an incorrect degradation setting.
- When opened ingame, team aspect menu drawed the model on bottom.
- Flag countdown would disappear when going to overtime.
- Carrier defense bonus was sometimes being given to the actual carrier.
- Using drawStringNum from HUD scripts crashed Warsow.
- Blood stains had an ugly gray area around them.
- Players command showed everyone with BE off with sv_battleye 2.
- Back button was in wrong place at UI sometimes.
- Two clients with the same ip couldn't connect to the same server (Windows).
- Second player in duel got removed from the challenger queue when changing
  map in warmup.
- Console kick command couldn't be used to kick connecting players.
- Sometimes the editing line in console got messed up.
- Demo playback had wrong speed.
- Doors with a team assigned weren't working properly.

Changes:
- Many weapons now have less pickup and/or max ammo.
- Backpack now only drops current weapon's ammo plus Gunblade ammo.
- Updated Makefile to be FreeBSD compatible.
- Removed reading and writing of dedicated.cfg.
- Server browser is now a little faster.
- Added mods menu to the UI.
- Flag carrier is now able to reset flag timer by touching his own base.
- HUD icon now showed when flag is in base.
- Added flag timer sounds.
- Flag timer now turns red when there is less than 2.5 seconds left.
- Capture time is now centerprinted to the player who made the capture.
- New settings cg_explosionsAlpha and cg_explosionsRingAlpha were added.
- Viewsize slider was removed from the UI.
- Strong riotgun reload time is now the same as weak one.
- Riotgun now shoots more pellets, but does less damage per pellet.
- Flag reset at wctf1 is now 8. 
- Remove instagib gametype, but add g_instagib server setting to make all
  gametypes instagib.
- Added cg_crosshair_strong, cg_crosshair_strong_color and
  cg_crosshair_strong_size settings.
- Added new callvotes: "mute <player>", "vmute <player>" (mutes vsays) and "allready".

:: :: Changes from 0.1 to 0.11

Bugfixes:
- Internal serverbrowser was missing servers.
- Servers could crash with zlib error.
- Scores didn't reset after warmup in CTF.
- When there were players in challenger queue and someone disconnected during
  countdown or playtime the match was not restarted.
- Map wdm5 was missing a teleport effect.
- UI failed to play demos with spaces in filenames.
- Long player names could go over the scores in scoreboards.
- say_team (and vsay_team) didn't work correctly when used with tokens that
  had color in them.
- Error messages when calling a vote where broadcasted to everybody.
- Password entry didn't work when using the OK button.

Changes:
- Moved crosshair size and color settings from HUD scripts to cvars
  (cg_crosshair_size, cg_crosshair_color).
- Added g_needpass and g_gametypes_available serverinfos for server browsers.
- Added setting for disabling all console printing (con_printText).
- Added flag status information for HUD scripts (STATS_CTF_FLAG_RED & BLUE,
  constants: FLAG_SAFE, FLAG_STOLEN, FLAG_DROPPED)
- Added reminder sound when ready up is needed.
- Added text telling current match state next to the clock in default HUD.

Linux only:
- For few users Warsow crashed when starting listen server.
- Non-DGA mouse didn't work properly.
- The X11 window name is now set.
- Binaries now built with no dynamic dependancy to libXxfdga and libXxfvm to
  work with older distributions (for example Debian Stable)
- There are now prebuilt 64bit binaries.

:: :: Changes from 0.072 to 0.1

Major new features:
- New weapon: Lasergun
- CTF gametype is now fully working.
- Voicecommands with headicons to communicate with your teammates and opponents
  (like in Enemy Territory).
- Map downloading both from game server and from web servers.
- Ability to use custom colors for all the player models.
- Possibility to force enemies and team mates to use predefined models and
  colors.
- New font system allowing the use of different fonts/sizes.
- Added in-game UI menu.
- Error screen when getting disconnected from server or when connection fails.
- Timeout system.
- Support for BattlEye anti-cheat engine (more information on
  http://www.battleye.com).
- Ability to show player names next to their models.
- Pointing teammate now shows their health and armor status.
- Challenger queue for duel servers.
- Race gametype has many new improvements.

Major changes:
- Totally new splash knockback system.
- Changing gametype doesn't require a map restart anymore.
- Make projectiles appear little ahead of the player instead of right in front
  of them. This makes projectile weapons feel more solid.
- New armor system.
- Many UI changes, especially to the internal serverbrowser.
- Netcode now uses zlib for compression.
- HUD system was rewritten.
- Many weapons have been tweaked in one way or another.
- Spawning is no longer forced to specific time, but inside certain timeframe.
  Faster respawning is now possible.
- The default server port is now 44400.
- Floats, instead of integers, are now used on server side for calculating
  player's health and armor.

New media:
- New announcer sounds by DJ Wheat of iTG.
- New CTF map: wctf1- ctf-russus
- New duel map: wdm5 - Viciious' home
- New midair map: wmid3 - hexagons
- New version of map wdm1 with major changes.
- New version of map wtest4 with major changes.
- New models and skins for several weapons: gunblade, plasmagun,
  grenadelauncher and electrobolt
- New skins for riotgun and rocketlauncher.
- Added lasergun model and skin.
- New ammobox and ammopack textures.
- New rocket, grenade and plasma projectile models and skins.
- New explosion effects for grenade, rocket and plasma.
- New rocket and grenade trails.
- Added a rocket flare.
- New menu graphics.
- Added a default levelshot image.
- New fonts.
- Added flags.
- New andromeda model skin.
- New chatbubble.
- Added teleporter effects.
- Most simpleitems redone.
- Most HUD weaponicons redone.
- Many new sound effects.
- Tweaked some old sound effects.

Major bugfixes:
General:
- Jumping on stairs didn't work right.
- Sometimes when connecting you could get stuck in the loading screen.
- There was no feedback why connecting to server wasn't succeeding.
- Players that lost connection sometimes didn't timeout, but took up space in
  the server forever.
- After walking through a teleporter, you might end up looking up or down.
- Automatic demos and screenshots didn't work with some nicknames.
- Internal serverbrowser sometimes stopped displaying all the servers.
- Telefrags could happen at the start of the match.
- The weapnext and weapprev commands didn't work correctly.
- Keyboard handling in the UI was broken.
- Some clients had big FPS drops once in a while.
Windows only:
- There could be a sound flood after using ALT-TAB.
Linux only:
- There were many troubles with keyboard handling.
- Stencilshadows didn't work.

More new features:
- Weapons stats, visible on scoreboard and with console command.
- Option to use simple projected shadows.
- Mousewheel support for scrolling in UI.
- Callvoting new gametype now also changes some related settings accordingly,
  like timelimit.
- Some camming features for demos. Still work in progress.
- Console now shows current time.
- Bots will also use voicecommands.
- Options to enable/disable screen shaking and flashing when getting hit.
- Option to disable model outlines.
- Automatically recorded demos are now sorted to subdirectories.
- Midair gametype has been improved in many ways.
- Player trails for race gametype.
- Possibility to use sudden death overtime.
- Scoreboard size can now be changed.
- Ability to relaxe input update ratio.
- Bots now adjust their skill according to server skill level.
- New gametype: Instagib
- Ability to lock/unlock teams and invite players to locked teams.
- Some new HUD elements and support for predefined (by the game) constants.
- Bots are smarter and have better aim.
- Self shadows on models.
- Armor models now have LOD (level of detail) submodels.
- Proper nickname validating.
- Add shortcuts to drop command for easily dropping current weapon or flag.
- Allow enabling/disabling compression of outgoing packets.
- Ability set filename for console logging.
- Warsow now checks for new version on startup.

More changes:
- Don't shoot when spawning.
- Hitbox is now little taller.
- Teammessage now have yellow tint.
- Crouching while in air is now allowed.
- Optional high resolution timer for Windows, enabled from commandline.
- Spawnpoints are now dropped to floor if they don't have nodrop spawnflag set.
- Limiting nickname length is now based on displayed characters (not counting
  color tokens).
- Allow changing HUD without vid_restart.
- avidemo command captures in jpeg format if r_screenshotJPG is set.
- Crosshair handling was moved inside HUD scripts.
- Color changes: now ^6 is magenta, ^8 orange and ^9 grey.
- Use Red and Blue as two first teams again.
- Pings now have colors in the scoreboard.
- Allow canceling writing of chat message by pressing enter when message is
  empty.
- Use Quake 3 Arena's version of TGA loading function.
- Improve team tabs so it sends smaller updates at a faster update ratio.
- Clearer optional centerprinted killmessages.
- Give all weapons and some armor in warmup.
- Don't allow shooting while in countdown.
- Walljump counter now resets after some time.
- ALT-TAB can be used to switch between fullscreen and windowed mode in Linux
  too now.

Complete list of bugfixes:
- After match was ended you might end up chasing a player who was in spectator
  mode.
- Small coordinates were shown instead of teleport effect.
- cg_showTeamLocations used underscores instead of spaces.
- After walking through a teleporter, you might end up looking up or down.
- In team game, when a player joined a team ingame he could get wrong skin
  color.
- Some walljump sounds didn't get played.
- Callvoting allow_falldamage didn't work.
- Quad effect wass not removed when changing to spectator.
- Server's info string didn't work right if the hostname was too long.
- When on server alone you could get disconnected with an overflow error.
- Some binds could get stuck when entering the message mode.
- Minus commands were called over and over again when releasing keys in console
  mode.
- Automatic demos and screenshots didn't work with some nicknames.
- cl_demoavi_scissor mistakenly worked with value 2 not with 1.
- Some TGA-textures could crash the game.
- Using jumppads didn't reset the walljump counter.
- Vote didn't fail immidiately even if it no longer had a change of passing.
- Internal serverbrowser sometimes stopped displaying all the servers.
- The game sometimes reported memory errors and crashes when using the UI.
- Sometimes when connecting you could get stuck in the loading screen.
- Clearing messagemode bind in the UI also cleared the messagemode2 bind.
- Adding bots to passworded server didn't work.
- Starting server from the UI could give wrong gametype.
- When gametype was changed an invalid scoreboard got displayed until the map
  was changed.
- There were several small bugs in map wdm1.
- Telefrags could happen at the start of the match.
- Grenades didn't bounce when hitting downward ramps.
- Strong gunblade had bigger starting ammo than max ammo.
- Shotgun blast sometimes looked different on client side than it actually was
  on server side.
- Port numbers were printed wrong in various places.
- The weapnext and weapprev commands didn't work correctly.
- Projectiles weren't removed when game started.
- In race mod the model didn't disappear when you respawned.
- It was possible to jump just before dying of a fall (you would still die
  though).
- Missing shader image is showed when levelshot was missing.
- When firing a gun that was out of ammo the no ammo sound might get played
  many times.
- Body or head gib disappeared, if the player who died disconnected or joined
  another team before respawning.
- Grenadelauncher's HUD icon had wrong color, when you had ammo but no weapon.
- There was a small texture missing in the players menu.
- Using gamemap with map that wasn't on the server would cause the game module
  to quit.
- Players that lost connection sometimes didn't timeout, but took up space in
  the server forever.
- There was no feedback why connecting to server wasn't succeeding.
- Sometimes the countdown got skipped.
- Some sounds didn't follow you like they should when in chasecam.
- Shards model was green, but simpleitem purple.
- Screen shaked when you were standing on someone's head.
- Sometimes the view shaked a little when you were in float cam mode.
- Client could fail if started with logconsole 1 set.
- The rate message could be colored by client's name.
- You needed one more frag than you should when using a scorelimit.
- Colors from spectator's name could effect his ping's color on scoreboard.
- Some things got left to the hud when you become spectator.
- Slime and lava only did health damage after you ran out of armor.
- There was a missing shader when using cg_viewsize value smaller than 100.
- Pressing delete key in chat mode produced a strange character.
- Keyboard handling in the UI was broken.
- The game clock was constantly jumping between 5:00 and 4:59 in warmup mode.
- If you hit someone at the last moment of the match, the hitsound would be
  played after the restart.
- Few cvars got reseted silently after changing them, when on non-cheat servers.
- Death messages were sometimes wrong.
- Disabling warmup put server in loop when not enough players were around.
- Some rocket splash hits didn't register when hitting next to small edges.
- Player model wasn't properly centered in the UI.
- Leaving a team when in countdown could be used to reset warmup timelimit.
- Some connectioneless commands on client didn't check where the message was
  coming from. This allowed anyone knowing the client port to print random
  stuff to his console and more.
- Some clients had big FPS drops once in a while.
Windows only:
- There could be an ugly sound flood after using ALT-TAB.
Linux only:
- Keyboard's * key was regocnized as * and not as KP_STAR.
- Caps/Num/ScrollLock couldn't be bound.
- Non-US keyboard layouts didn't work well.
- Keys that aren't used for console (like F1) were repeated when pressed while
  console was active.
- Stencilshadows didn't work.
- in_restart command stopped the input system.
- UI for changing sound quality didn't work.
Total of 74 user visible bugs from version 0.072a fixed.
